gsu_getopts: Abort on programming errors and add documentation.
[gsu.git] / funcs / gsu
index 129757ace42a3cdeaa0b72cc582f97a3eb3d289c..673605e43bbca8e66940722b7c587b72ba84964b 100644 (file)
--- a/funcs/gsu
+++ b/funcs/gsu
@@ -1,6 +1,6 @@
-#!/bin/sh
+#!/bin/bash
 # gsu -- the global subcommand utility
 # gsu -- the global subcommand utility
-# (C) 2006-2009 Andre Noll
+# (C) 2006-2010 Andre Noll
 
 _gsu_init_errors()
 {
 
 _gsu_init_errors()
 {
@@ -8,13 +8,14 @@ _gsu_init_errors()
 GSU_SUCCESS                    success
 E_GSU_BAD_COMMAND              invalid command
 E_GSU_NOT_A_NUMBER             not a number
 GSU_SUCCESS                    success
 E_GSU_BAD_COMMAND              invalid command
 E_GSU_NOT_A_NUMBER             not a number
-E_GSU_SOURCE                   error in config file
-E_GSU_CONFIG                   bad/missing config file option
 E_GSU_BAD_CONFIG_VAR           invalid config variable
 E_GSU_NEED_VALUE               value required but not given
 E_GSU_BAD_BOOL                 bad value for boolian option
 E_GSU_BAD_OPTION_TYPE          invalid option type
 E_GSU_BAD_CONFIG_VAR           invalid config variable
 E_GSU_NEED_VALUE               value required but not given
 E_GSU_BAD_BOOL                 bad value for boolian option
 E_GSU_BAD_OPTION_TYPE          invalid option type
-E_NO_DEFAULT                   missing default value
+E_GSU_BAD_ARG_COUNT            invalid number of arguments
+E_GSU_EDITOR                   failed to execute editor
+E_GSU_MKDIR                    failed to create directory
+E_GSU_GETOPTS                  getopts error
 $gsu_errors
 "
        local a b i=0
 $gsu_errors
 "
        local a b i=0
@@ -44,6 +45,37 @@ gsu_is_a_number()
 }
 export -f gsu_is_a_number
 
 }
 export -f gsu_is_a_number
 
+# Check number of arguments.
+#
+# Usage: gsu_check_arg_count <num_given> <num1> [<num2>]
+#
+# Check that <num_given> is between <num1> and <num2> inclusively.
+# If only <num1> ist given, num2 is assumed to be infinity.
+#
+# Examples:
+#      0 0 no argument allowed
+#      1 1 exactly one argument required
+#      0 2 at most two arguments admissible
+#      2   at least two arguments reqired
+#
+gsu_check_arg_count()
+{
+       ret=-$E_GSU_BAD_ARG_COUNT
+       if [[ $# -eq 2 ]]; then # only num1 is given
+               result="at least $2 args required, $1 given"
+               [[ $1 -lt $2 ]] && return
+               ret=$GSU_SUCCESS
+               return
+       fi
+       # num1 and num2 given
+       result="need at least $2 args, $1 given"
+       [[ $1 -lt $2 ]] && return
+       result="need at most $3 args, $1 given"
+       [[ $1 -gt $3 ]] && return
+       ret=$GSU_SUCCESS
+}
+export -f gsu_check_arg_count
+
 gsu_short_msg()
 {
        echo "$1" 1>&2
 gsu_short_msg()
 {
        echo "$1" 1>&2
@@ -62,15 +94,17 @@ gsu_date_msg()
 }
 export -f gsu_date_msg
 
 }
 export -f gsu_date_msg
 
+
+
 _gsu_banner_msg()
 {
 _gsu_banner_msg()
 {
-       local txt="*** $_gsu_self --"
+       local txt="### $_gsu_self --"
        if test -z "$gsu_banner_txt"; then
                txt="$txt set \$gsu_banner_txt to customize this message"
        else
                txt="$txt $gsu_banner_txt"
        fi
        if test -z "$gsu_banner_txt"; then
                txt="$txt set \$gsu_banner_txt to customize this message"
        else
                txt="$txt $gsu_banner_txt"
        fi
-       gsu_short_msg "$txt ***"
+       gsu_short_msg "$txt ###"
 }
 export -f _gsu_banner_msg
 
 }
 export -f _gsu_banner_msg
 
@@ -99,7 +133,7 @@ export -f gsu_err_msg
 
 _gsu_usage()
 {
 
 _gsu_usage()
 {
-       gsu_short_msg "Usage: $_gsu_self command [options]"
+       gsu_short_msg "Usage: $_gsu_self command [options]"
 }
 export -f _gsu_usage
 
 }
 export -f _gsu_usage
 
@@ -137,13 +171,27 @@ export -f _gsu_print_available_commands
 export gsu_prefs_txt="
 Print the current preferences.
 
 export gsu_prefs_txt="
 Print the current preferences.
 
-Usage: prefs
+Usage: prefs [-e]
 
 
-Print out a list of all cmt config variables, together with their current value
-and the default value."
-com_prefs()
+If -e is given, the config file is opened with the default editor.  Without
+options, the command prints out a list of all cmt config variables, together
+with their current value and the default value."
+_com_prefs()
 {
 {
-       local i
+       local i conf="${gsu_config_file:=$HOME/.$gsu_name.rc}"
+
+       if [[ "$1" = "-e" ]]; then
+               ret=-$E_GSU_MKDIR
+               result="${conf%/*}"
+               mkdir -p "$result"
+               [[ $? -ne 0 ]] && return
+               ret=-$E_GSU_EDITOR
+               result="${EDITOR:-vi}"
+               "$result" "$conf"
+               [[ $? -ne 0 ]] && return
+               ret=$GSU_SUCCESS
+               return
+       fi
 
        for ((i=0; i < ${#gsu_options[@]}; i++)); do
                local name= option_type= default_value= required=
 
        for ((i=0; i < ${#gsu_options[@]}; i++)); do
                local name= option_type= default_value= required=
@@ -163,19 +211,20 @@ com_prefs()
                        printf " [$default_value]"
                fi
                echo
                        printf " [$default_value]"
                fi
                echo
+               [[ -n "$help_text" ]] && sed -e '/^[    ]*$/d; s/^[     ]*/#    /g' <<< "$help_text"
                printf "$name=$val"
                [[ "$val" == "$default_value" ]] && printf " # default"
                echo
        done
 }
                printf "$name=$val"
                [[ "$val" == "$default_value" ]] && printf " # default"
                echo
        done
 }
-export -f com_prefs
+export -f _com_prefs
 
 export gsu_man_txt="
 Print the manual.
 
 Usage: man"
 
 
 export gsu_man_txt="
 Print the manual.
 
 Usage: man"
 
-com_man()
+_com_man()
 {
        local equal_signs="=================================================="
        local minus_signs="--------------------------------------------------"
 {
        local equal_signs="=================================================="
        local minus_signs="--------------------------------------------------"
@@ -212,7 +261,7 @@ com_man()
         done
         ret=$GSU_SUCCESS
 }
         done
         ret=$GSU_SUCCESS
 }
-export -f com_man
+export -f _com_man
 
 export gsu_help_txt="
 Print online help.
 
 export gsu_help_txt="
 Print online help.
@@ -222,19 +271,18 @@ Usage: help [command]
 Without arguments, print the list of available commands. Otherwise,
 print the help text for the given command."
 
 Without arguments, print the list of available commands. Otherwise,
 print the help text for the given command."
 
-com_help()
+_com_help()
 {
        local a b
        if test -z "$1"; then
                _gsu_banner_msg 2>&1
                _gsu_usage 2>&1
 {
        local a b
        if test -z "$1"; then
                _gsu_banner_msg 2>&1
                _gsu_usage 2>&1
-               # sed is magic, baby
-               (printf "com_help()\n$gsu_help_txt" | head -n 4; echo "--"
-               printf "com_man()\n$gsu_man_txt" | head -n 4; echo "--"
-               printf "com_prefs()\n$gsu_prefs_txt" | head -n 4; echo "--"
-
-               grep -A 2 "^com_\([a-zA-Z_0-9]\+\)()" $0) \
-                       | grep -v -- '--' \
+               {
+                       printf "com_help()\n$gsu_help_txt" | head -n 4; echo "--"
+                       printf "com_man()\n$gsu_man_txt" | head -n 4; echo "--"
+                       printf "com_prefs()\n$gsu_prefs_txt" | head -n 4; echo "--"
+                       grep -A 2 "^com_\([a-zA-Z_0-9]\+\)()" $0
+               } | grep -v -- '--' \
                        | sed -e '/^com_\([a-zA-Z_0-9]\+\)()/bs' \
                                -e 'H;$!d;x;s/\n//g;b' \
                                -e :s \
                        | sed -e '/^com_\([a-zA-Z_0-9]\+\)()/bs' \
                                -e 'H;$!d;x;s/\n//g;b' \
                                -e :s \
@@ -249,7 +297,7 @@ com_help()
                                echo "$b"
                         done
                echo
                                echo "$b"
                         done
                echo
-               echo "Try $_gsu_self help <command> for info on <command>."
+               echo "Try $_gsu_self help <command> for info on <command>."
                ret=$GSU_SUCCESS
                return
        fi
                ret=$GSU_SUCCESS
                return
        fi
@@ -270,27 +318,33 @@ com_help()
        fi
        ret=$GSU_SUCCESS
        if grep -q "^com_$1()" $0; then
        fi
        ret=$GSU_SUCCESS
        if grep -q "^com_$1()" $0; then
-               sed -e "1,/com_$1()/d" -e '/^{/,$d' -e 's/^## *//' $0
+               sed -e "1,/^com_$1()$/d" -e '/^{/,$d' -e 's/^## *//' $0
                return
        fi
        _gsu_print_available_commands
        result="$1"
        ret=-$E_GSU_BAD_COMMAND
 }
                return
        fi
        _gsu_print_available_commands
        result="$1"
        ret=-$E_GSU_BAD_COMMAND
 }
-export -f com_help
+export -f _com_help
 
 # internal gsu function that syntactically checks the gsu_options array
 # for errors and parses the config file.
 _gsu_check_options()
 {
 
 # internal gsu function that syntactically checks the gsu_options array
 # for errors and parses the config file.
 _gsu_check_options()
 {
-       local i conf="${gsu_config_file:=$HOME/.$gsu_name.rc}"
+       local i conf="${gsu_config_file:=$HOME/.$gsu_name.rc}" val
+
+       for ((i=0; i < ${#gsu_options[@]}; i++)); do
+               eval "${gsu_options[$i]}"
+               eval val='"'\$$name'"'
+               eval orig_${gsu_config_var_prefix}_$name='"'${val}'"'
+       done
 
        [[ -r "$conf" ]] && source "$conf"
 
        for ((i=0; i < ${#gsu_options[@]}; i++)); do
                local name= option_type= default_value= required=
                local description= help_text=
 
        [[ -r "$conf" ]] && source "$conf"
 
        for ((i=0; i < ${#gsu_options[@]}; i++)); do
                local name= option_type= default_value= required=
                local description= help_text=
-               local val
+               local val orig_val
 
                eval "${gsu_options[$i]}"
 
 
                eval "${gsu_options[$i]}"
 
@@ -299,12 +353,17 @@ _gsu_check_options()
                # only.  Moreover it must not start with [a-zA-Z].
 
                ret=-$E_GSU_BAD_CONFIG_VAR
                # only.  Moreover it must not start with [a-zA-Z].
 
                ret=-$E_GSU_BAD_CONFIG_VAR
-               result="$name"
+               result="name: '$name'"
                # bash's =~ works only for 3.2 and newer, so use grep
                echo "$name" | grep '^[a-zA-Z][a-zA-Z_0123456789]*$' &> /dev/null;
                [[ $? -ne 0 ]] && return
 
                # bash's =~ works only for 3.2 and newer, so use grep
                echo "$name" | grep '^[a-zA-Z][a-zA-Z_0123456789]*$' &> /dev/null;
                [[ $? -ne 0 ]] && return
 
-               eval val='"'\$$name'"'
+               eval orig_val='"'\$orig_${gsu_config_var_prefix}_$name'"'
+               if [[ -z "$orig_val" ]]; then
+                       eval val='"'\$$name'"'
+               else
+                       val="$orig_val"
+               fi
                case "$required" in
                true|yes)
                        ret=-$E_GSU_NEED_VALUE
                case "$required" in
                true|yes)
                        ret=-$E_GSU_NEED_VALUE
@@ -320,7 +379,6 @@ _gsu_check_options()
                esac
 
                eval ${gsu_config_var_prefix}_$name='"'${val:=$default_value}'"'
                esac
 
                eval ${gsu_config_var_prefix}_$name='"'${val:=$default_value}'"'
-
                # Check option type. ATM, only num and string are supported
                # Other types may be added without breaking compatibility
                case "$option_type" in
                # Check option type. ATM, only num and string are supported
                # Other types may be added without breaking compatibility
                case "$option_type" in
@@ -340,17 +398,106 @@ _gsu_check_options()
 }
 export -f _gsu_check_options
 
 }
 export -f _gsu_check_options
 
+# Wrapper for bash's getopts.
+#
+# Aborts on programming errors such as missing or invalid option string.  On
+# success $result contains shell code that can be eval'ed. For each defined
+# option x, the local variable o_x will be created when calling eval "$result".
+# o_x contains true/false for options without an argument or the emtpy string/the
+# given argument, depending on whether this option was contained in the "$@"
+# array.
+#
+# Example:
+#      gsu_getopts abc:x:y
+#      eval "$result"
+#      [[ $ret -lt 0 ]] && return
+#
+#      [[ "$o_a" = "true ]] && echo "The -a flag was given"
+#      [[ -n "$o_c" ]] && echo "The -c option was given with arg $o_c"
+gsu_getopts()
+{
+       local i c tab=' ' cr='
+'
+
+       gsu_check_arg_count $# 1 1
+       if [[ $ret -lt 0 ]]; then
+               gsu_err_msg
+               exit 1
+       fi
+
+       ret=-$E_GSU_GETOPTS
+       result="invalid optstring $1"
+       if [[ -z "$1" || "$1" =~ "::" ]]; then
+               gsu_err_msg
+               exit 1
+       fi
+
+       for ((i=0; i < ${#1}; i++)); do
+               c=${1:$i:1}
+               case "$c" in
+               [a-zA-Z:]);;
+               *)
+                       ret=-$E_GSU_GETOPTS
+                       result="invalid character $c in optstring"
+                       gsu_err_msg
+                       exit 1
+               esac
+       done
+       result="local opt"
+       for ((i=0; i < ${#1}; i++)); do
+               c1=${1:$i:1}
+               c2=${1:$(($i + 1)):1}
+               result+=" o_$c1"
+               if [[ "$c2" = ":" ]]; then
+                       let i++
+               else
+                       result+="=false"
+               fi
+       done
+       result+="
+       OPTIND=1
+       while getopts $1 opt \"\$@\"; do
+               case \"\$opt\" in
+"
+       for ((i=0; i < ${#1}; i++)); do
+               c1=${1:$i:1}
+               c2=${1:$(($i + 1)):1}
+               result+="$tab$tab$c1) o_$c1="
+               if [[ "$c2" = ":" ]]; then
+                       result+="\"\$OPTARG\""
+                       let i++
+               else
+                       result+="true"
+               fi
+               result+=";;$cr"
+       done
+       result+="
+               *)
+                       ret=-\$E_GSU_GETOPTS
+                       result=\"invalid option given\"
+                       return
+                       ;;
+               esac
+       done
+       shift \$((\$OPTIND - 1))
+"
+       ret=$GSU_SUCCESS
+}
+export -f gsu_getopts
+
 gsu()
 {
        local i
 gsu()
 {
        local i
-
        _gsu_self="$(basename $0)"
        _gsu_self="$(basename $0)"
+       gsu_name="${gsu_name:=$_gsu_self}"
        gsu_config_var_prefix="${gsu_config_var_prefix:=$gsu_name}"
        _gsu_init_errors
        _gsu_check_options
        if [[ "$ret" -lt 0 ]]; then
        gsu_config_var_prefix="${gsu_config_var_prefix:=$gsu_name}"
        _gsu_init_errors
        _gsu_check_options
        if [[ "$ret" -lt 0 ]]; then
-               gsu_err_msg
-               exit 1
+               if [[ "$1" != "help" && "$1" != "man" ]]; then
+                       gsu_err_msg
+                       exit 1
+               fi
        fi
        _gsu_available_commands
        gsu_cmds="$result"
        fi
        _gsu_available_commands
        gsu_cmds="$result"
@@ -361,16 +508,28 @@ gsu()
        fi
        arg="$1"
        shift
        fi
        arg="$1"
        shift
+       # check internal commands
+       if [[ "$arg" = "help" || "$arg" = "man" || "$arg" = "prefs" ]]; then
+               _com_$arg "$@"
+               if [[ "$ret" -lt 0 ]]; then
+                       gsu_err_msg
+                       exit 1
+               fi
+               exit 0
+       fi
+
+       # external commands
        for i in $gsu_cmds; do
                if test "$arg" = "$i"; then
                        com_$arg "$@"
        for i in $gsu_cmds; do
                if test "$arg" = "$i"; then
                        com_$arg "$@"
-                       if test $ret -lt 0; then
+                       if [[ "$ret" -lt 0 ]]; then
                                gsu_err_msg
                                exit 1
                        fi
                        exit 0
                fi
        done
                                gsu_err_msg
                                exit 1
                        fi
                        exit 0
                fi
        done
+
        ret=-$E_GSU_BAD_COMMAND
        result="$arg"
        gsu_err_msg
        ret=-$E_GSU_BAD_COMMAND
        result="$arg"
        gsu_err_msg